<nz-table *ngIf="checklist" #checklistTable [nzData]="checklist.actions" [nzShowPagination]="false" nzSize="small">
  <thead *ngIf="header">
    <tr>
      <th [nzWidth]="nameWidth ?? null">{{checklist.name}}</th>
      <th [nzWidth]="'100%'" colSpan="2">{{checklist.desc}}</th>
      <th [nzWidth]="'40px'">
        <app-done [done]="(checklist.done$ | async)"></app-done>
      </th>
    </tr>
  </thead>
  <tbody>
    <tr *ngFor="let data of checklistTable.data;let i = index" class="row" [nzDisabled]="data.disabled"
      [class.disabled]="data.disabled" (click)="toggleDoneAction(data)" nz-typography
      [nzType]="data.done ? 'success' : 'danger'">
      <td>
        <span class="color-transition">
          {{data.name}}
        </span>
      </td>
      <td>
        <span class="color-transition" *ngIf="editAction?.key !== data.key">
          {{data.desc}}
        </span>
        <input nz-input [placeholder]="checklist.desc" nzSize="small" (blur)="editAction = undefined"
          *ngIf="data.editable && editAction?.key === data.key" (click)="$event.stopPropagation()"
          [formControl]="descControls[i]" (keyup.enter)="editAction = undefined"
          (keyup.escape)="editAction = undefined" />
      </td>
      <td>
        <span nz-typography nzType="secondary" class="action-button">
          <button nz-button nzSize="small" nzShape="circle" *ngIf="data.canDisable"
            (click)="$event.stopPropagation();toggleDisable(data)" nz-tooltip nzTooltipTitle="Disable"
            nzTooltipPlacement="right">
            <i nz-icon nzType="stop" nzTheme="outline"></i>
          </button>
          <button nz-button nzSize="small" nzShape="circle" *ngIf="data.editable && !data.disabled"
            (click)="$event.stopPropagation();editAction = data" nz-tooltip nzTooltipTitle="Edit {{checklist.desc}}"
            nzTooltipPlacement="right">
            <i nz-icon nzType="edit" nzTheme="outline"></i>
          </button>
        </span>
      </td>
      <td class="done">
        <i nz-icon [nzType]="data.done ? 'check-square' : 'close-square'" nzTheme="fill" class="color-transition"></i>
      </td>
    </tr>
  </tbody>
</nz-table>